#include "Event.hpp"

Delegate::Delegate(IObject * pHandler,EventHandler pfnCallback) throw() : Object(pHandler),Sender(0),
    Args(0)
{
    Callback = pfnCallback;
}

Delegate::Delegate(GlobalEventHandler pfnCallback) throw() : Object(0),Sender(0),Args(0)
{
    GlobalCallback = pfnCallback;
}

Delegate::~Delegate() throw()
{
}

void Delegate::Invoke() throw()
{
    if (Object != 0)
    {
        (Object->*Callback)(Sender,Args);
    }
    else
    {
        GlobalCallback(Sender,Args);
    }
}

void Delegate::SetArguments(IObject * pSender,EventArgs * pArgs) throw()
{
    Sender = pSender;
    Args = pArgs;
}

IObject * Delegate::GetObject() const throw()
{
    return Object;
}

EventHandler Delegate::GetCallback() const throw()
{
    return Callback;
}
